\name{S1}
\alias{S1}
\docType{data}
\title{Memory IgD+ B cell IMGT/HighV-QUEST output
}
\description{
The data of one set from IMGT/HighV-QUEST output used here as an example.
}
\usage{data("S1")}
\format{
  A data frame with 27731 observations on the following 26 variables:

  cdr3aa: CDR3-IMGT sequence (AA)

  expid:  Experimental ID

  clonoIndex:  Representative sequence index

  onecopy:  Nb of '1 copy'

  morethanone:  Nb of 'More than one'

  total:  Total nb of '1 copy' and 'More than one'

  indexes: '1 copy' Indexes

  vgene:  V-gene

  vallele:  V-allele

  dgene:  D-gene

  dallele:  D-allele

  jgene:  J-gene

  jallele:  J-allele

  cdr1:  CDR1-IMGT

  cdr2:  CDR2-IMGT

  gcdr1:  CDR1-IMGT gapped sequence (AA)

  gcdr2: CDR2-IMGT gapped sequence (AA)

  pid: \% identity with the closest germline IMGT V gene and allele

  length:  Sequence length

  c104: C104 (1st-CYS)

  f118: F118 or W118 (J-PHE or J-TRP)

  anchors: Anchors (C104, F118 or W118)

  seqid:  Sequence ID

  functionality: Functionality

  sequenceFileNumber: Sequence file number

  sequenceClonoFileNumber: Sequence clonotype file number}
\source{Sequencing data used for this example is available in the NCBI Sequence Read Archive under the accession code SRX470417. The description of this data is available in Mroczek E.S. et al. (2014).

}
\references{
Mroczek E.S., Ippolito G.C., Rogosch T., Hoi K.H., Hwangpo T.A., Brand M.G. et al. (2014) Differences in the composition of the human antibody repertoire by B cell subsets in the blood. Front Immunol. 5:96. doi:  10.3389/fimmu.2014.00096. PMID: 24678310.

}
\examples{
\donttest{
 data(S1)
 str(S1)
}
}
\keyword{datasets}
